package com.webchat.client.chat.controller;


import com.webchat.client.chat.service.MomentService;
import com.webchat.common.bean.APIResponseBean;
import com.webchat.common.bean.APIResponseBeanUtil;
import com.webchat.common.config.annotation.SafeClick;
import com.webchat.common.enums.ClickEvent;
import com.webchat.common.helper.SessionHelper;
import com.webchat.domain.vo.request.MomentSaveOrUpdateVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/client-service/moment")
public class MomentController {


    @Autowired
    private MomentService momentService;

    /**
     * 发布动态
     *
     * @return
     */
    @SafeClick(event = ClickEvent.PUBLISH_MOMENT, time = 2000, message = "动态发布中，请勿重复操作")
    @PostMapping("/publish")
    public APIResponseBean<Long> publish(@RequestBody MomentSaveOrUpdateVO momentSaveOrUpdate) {

        momentSaveOrUpdate.validateRequestParam();

        String author = SessionHelper.getCurrentUserId();
        momentSaveOrUpdate.setAuthor(author);
        Long momentId = momentService.publish(momentSaveOrUpdate);
        return APIResponseBeanUtil.success(momentId);
    }
}
